<template>
  <div class="portfolio_page">
    <div :class="{'portfolio_wrap': true, 'portfolio_wrap_active': this.$store.state.loadPage }">
      <div class="portfolio_nav">
        <ul>
          <li v-for="(value, type, index) in proj_types" v-on:click="selectTypeProject" v-bind:class="{ active_type: value['active'] }">
            {{ type }}
          </li>
        </ul>
      </div>
      <div class="portfolio_content">
        <div class="projects_wrap" v-images-loaded="imageLoaded">
          <transition-group name="list-complete" tag="div" >
            <div v-for="(project, index) in proj_list" class="prj_item list-complete-item" v-bind:key="project.pk" v-if='index < proj_count'>
              <div>
                <router-link :to="{ path: '/portfolio/' + project.pk}">
                  <div class="project_wrap_sheet">
                    <div>
                      <h4>{{ project.title }}</h4>
                      <!-- <p>{{ project.location }}</p> -->
                    </div>
                  </div>
                  <img v-bind:src="project.project_images[0].image" alt="" />
                </router-link>
              </div>
            </div>
          </transition-group>
        </div>
        <button v-on:click="showMore" :class="{'hide': shovHideButton }" >Еще</button>
      </div>
      <span class="scroll_icon" @click="portolioScrollTop"><icon class="fa-icon" name="arrow-circle-o-up" scale="2"></icon></span>
      <div class="custom_footer" :class="{'portfolio_wrap_active': this.$store.state.loadPage }">
        <my-footer></my-footer>
      </div>
    </div>
  </div>
</template>


<script>
import axios from 'axios'
import imagesLoaded from 'vue-images-loaded'

export default {
  name: 'portfolio',
  directives: {
      imagesLoaded,
  },
  data () {
    return {
      proj_types: {
        'Все проекты': { 'active': true }
        },
      def_proj_list: [],
      proj_list: [],
      current_type: 'Все проекты',
      show_button_more: true,
      def_count_proj: 3,
      proj_count: 3,
      inc_proj_count: 3,
      count_of_types: {},
      flag: true,
      shovHideButton: false
    }
  },

  created () {
    this.$store.commit('setLoadpage', false)
  },

  mounted: function () {
    let url = this.$store.state.domain + 'projects'
    axios.get(url).then(res => {
      this.def_proj_list = res.data;
      for(let i = 0; i < this.def_proj_list.length; i++){
        if (this.def_proj_list[i].project_images) {
          let types = this.def_proj_list[i]['type_project'].replace(/^\s+|\s+$/g,'').split(',')
          for(let j = 0; j < types.length; j++ ){
            if (!(this.proj_types[types[j]])){
              this.proj_types[types[j]] = { 'active': false }
            }
          }
        }
      }
      for(let i = 0; i < this.def_proj_list.length; i++){
          this.proj_list.push(this.def_proj_list[i])
      }

      if (this.def_count_proj >= this.proj_list.length) {
        this.shovHideButton = true
      }
    })
  },

  methods: {
    imageLoaded: function(instance) {
        this.$store.commit('setLoadpage', true)
    },

    selectTypeProject: function(event){
      this.current_type = event.target.innerText.replace(/^\s+|\s+$/g,'').toLowerCase()
      this.proj_count = this.def_count_proj;

      if (this.current_type === 'все проекты'){
        this.proj_list = this.def_proj_list;
      }else{
        this.proj_list = selectProjects(this.def_proj_list, this.current_type)
      }

      for (let key in this.proj_types) {
        this.proj_types[key]['active'] = false
        if(key.toLowerCase() == this.current_type) {
          this.proj_types[key]['active'] = true
        }
      }

      if (this.proj_count < this.proj_list.length ){
        this.shovHideButton = false
      }else{
        this.shovHideButton = true
      }

      $('.portfolio_content').css('opacity', 0);
      $('.portfolio_content').animate({opacity: 1}, 500);

      this.load_img_count = 0;
    },

    showMore: function(event){
      let self = this
      this.load_img = false
      this.proj_count = this.proj_count + this.inc_proj_count;
      if (this.proj_count >= this.proj_list.length ){
        this.shovHideButton = true
      }

      $("html, body").animate({ scrollTop: $(document).height() }, 'slow');

      $(window).scroll(function(e) {
        if($(this).scrollTop() > 150) {
          if(this.flag){
              $(".scroll_icon").animate({opacity: "0.8"}, 500);
          }
          this.flag = false
        }
        if($(this).scrollTop() < 50){
          if(!this.flag){
              $(".scroll_icon").animate({opacity: "0"}, 500);
          }
          this.flag = true
        }
      });
    },

    portolioScrollTop: function() {
      $('html, body').animate({scrollTop:0}, 'slow');
    }
  }
}

function selectProjects(projects, type){
  var prj_list = [];
  for(var i = 0; i < projects.length; i++){
    if(projects[i]['type_project'].toLowerCase().split(',').indexOf(type) >=0) {
      prj_list.push(projects[i])
    }
  }
  return prj_list
}

</script>

<style>
.portfolio_page {
  max-width: 1200px;
  margin: auto;
}

.portfolio_wrap {
  position: relative;
  display: none;
  margin: auto;
  z-index: -2;
  text-align: center;
}

.portfolio_wrap_active {
  display: block;
  z-index: 0;
}

.portfolio_nav {
  text-align: right;
}

.portfolio_nav ul {
  display: flex;
  flex-flow: row wrap;
  justify-content: flex-end;
}

.portfolio_nav ul li {
  font-size: 16px;
  padding: 15px 20px;
  text-transform: capitalize;
}

.portfolio_nav ul li:last-child {
  padding-right: 0px;
}

.portfolio_nav ul li:hover {
  /* color: #fff; */
  cursor: pointer;
  /* background: graн; /* For browsers that do not support gradients */
}

.portfolio_content {
  padding: 20px 0px 0px 0px;
  /* background-color: #fff; */
}

.projects_wrap {
  display: flex;
  flex-flow: row wrap;
  justify-content: space-around;
}

.prj_item {
  min-width: 300px;
  width: 33.2%;
  /* border-left: 5px solid #fff;
  border-right: 5px solid #fff; */
  position: relative;
}

.prj_item img {
  width: inherit;
}


.portfolio_content button {
  height: 45px;
  background: #000;
  color: #fff;
  font-size: 16px;
  display: inline-block;
  padding: 6px 25px;
  margin: 20px auto 30px;
  cursor: pointer;
}

.portfolio_content button.hide {
  display: none;
}

.project_wrap_sheet {
  display: flex;
  flex-direction: column;
  justify-content: center;
  position: absolute;
  width: 100%;
  height: 100%;
  background-color: rgba(0, 0, 0, 0.5);
  opacity: 0;
  cursor: pointer;
  -webkit-transition: width 2s; /* For Safari 3.1 to 6.0 */
  transition: opacity 1s;
}

.prj_item:hover .project_wrap_sheet {
  opacity: 1
}

.active_type {
  color: #fff;
  cursor: pointer;
  background: #000; /* For browsers that do not support gradients */
  background: -webkit-linear-gradient(#000, #fff); /* For Safari 5.1 to 6.0 */
  background: -o-linear-gradient(#000, #fff); /* For Opera 11.1 to 12.0 */
  background: -moz-linear-gradient(#000, #fff); /* For Firefox 3.6 to 15 */
  background: linear-gradient(#000 80%, rgba('255', '255', '255', 0) 80%); /* Standard syntax */
}

.project_wrap_sheet h4, .project_wrap_sheet p {
  color: #fff;
  font-size: 14px;
}

.project_wrap_sheet p {
  margin: 20px;
  color: #fff;
}

.list-complete-item {
  transition: all 1s;
  display: inline-block;
}
.list-complete-enter, .list-complete-leave-to
  /* .list-complete-leave-active до версии 2.1.8 */ {
  opacity: 0;
  transform: translateY(100px);
}
.list-complete-leave-active {
  position: absolute;
}

.scroll_icon{
  opacity: 0;
  color: black;
	cursor: pointer;
  position: fixed;
	bottom: 20px;
	right: 20px;
	font-size: 36px;
}


@media screen and (max-width: 1024px) {
  .prj_item {
    min-width: 300px;
    width: 49%;
  }
}

@media screen and (max-width: 768px) {
  .prj_item {
    min-width: 275px;
    width: 100%;
    margin: 10px 0px;
  }

  .portfolio_nav ul {
    display: flex;
    flex-flow: row wrap;
    justify-content: flex-start;
  }

  .portfolio_nav ul li {
    text-align: center;
    flex-grow: 1;
    border: 1px solid black;
  }

  .active_type {
    background: black;
  }
}

</style>
